/* Estructura para utilizar aritmtica compleja en programas C.
   Francsco Dominguez-Adame                                          */

typedef struct {
   double re;
   double im;
} complejo;

complejo asigna(double real,double imag) {      /* Asignacin         */
   complejo temp;
   temp.re=real;
   temp.im=imag;
   return temp;
}

complejo s(complejo a,complejo b) {             /* Suma a+b          */
   complejo temp;
   temp.re=a.re+b.re;
   temp.im=a.im+b.im;
   return temp;
}

complejo m(complejo a,complejo b) {             /* Resta a-b         */
   complejo temp;
   temp.re=a.re-b.re;
   temp.im=a.im-b.im;
   return temp;
}

complejo x(complejo a,complejo b) {             /* Producto a*b       */
   complejo temp;
   temp.re=a.re*b.re-a.im*b.im;
   temp.im=a.re*b.im+a.im*b.re;
   return temp;
}

complejo c(complejo a,complejo b) {             /* Cociente a/b       */
   complejo temp;
   double norma2_b=b.re*b.re+b.im*b.im;
   temp.re=(a.re*b.re+a.im*b.im)/norma2_b;
   temp.im=(a.im*b.re-a.re*b.im)/norma2_b;
   return temp;
}

double norma2(complejo a) {                     /* Mdulo al cuadrado */
   return (a.re*a.re+a.im*a.im);
}

complejo cexp(complejo a) {                     /* Exponencial        */
   complejo temp;
   temp.re=exp(a.re)*cos(a.im);
   temp.im=exp(a.re)*sin(a.im);
   return temp;
}
