/* Cdigo para el estudio de la densidad acumulada de modos en
   cadenas armnicas peridicas. Mtodos analtico y numrico.
   Francisco Domnguez-Adame.                                         */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N        1000         /* Nmero de tomos de la cadena        */
#define LMAX        5.        /* Parmetro lambda mximo              */
#define LMIN        0.        /* Parmetro lambda mnimo              */
#define DL          0.1       /* Incremento del parmetro lambda      */
#define PI          3.141592654
#define FILENAME "DATOS.DAT"  /* Nombre del archivo                   */

void main(void) {
   double ra,rd,lambda,aux,dlambda=DL;
   int k,idos;
   FILE *out;
   out=fopen(FILENAME,"w");
   for(lambda=LMIN;lambda<=LMAX;lambda+=dlambda) {
      ra=0.;
      idos=0;
      for(k=1;k<N;k++) {           /* Bucle sobre cada cadena         */
         rd=2.-lambda-ra;
         if(fabs(rd)<1e-50) {
            idos++;
            k++;
            ra=0.;
         } else {
            if(rd<0.) idos++;
            ra=1./rd;
         }
      }
      if(lambda<4.) aux=(2./PI)*asin(sqrt(lambda/4.));
      else aux=1.;
      fprintf(out,"%8.6lf  %8.6lf  %8.6lf\n",lambda,(double)idos/N,aux);
   }
   fclose(out);
}
