/* Cdigo para el clculo de la densidad acumulada de modos
   en cadenas rmonicas cuasiperidicas de Fibonacci.
   Francisco Domnguez-Adame.                                         */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N 1597          /* Nmero de tomos de la cadena              */
#define MA   1.0        /* Masa de los tomos A                       */
#define MB   2.0        /* Masa de los tomos B                       */
#define NL 2000         /* Nmero de frecuencias                      */
#define LMIN 0.0        /* Frecuencia mnima                          */
#define LMAX 4.0        /* Frecuencia mxima                          */
#define FILENAME  "DATOS.DAT"  /* Archivo de datos                    */

double alfa[N+1];       /* Vector con las masas reducidas             */

void red (void)  {      /* Genera la cadena de Fibonacci              */
   int i;
   double aux0,aux1,w=0.5*sqrt(5.)-0.5;
   for (i=1;i<=N;i++)  {
      aux0=(double) (i)/w;
      aux1=(double) (i+1)/w;
      alfa[i]=MB/MA+(1.-MB/MA)*(floor(aux1)-floor(aux0)-1.);
   }
}

void main(void) {
   int k,idos;
   double lambda,ra,rd,dlambda=(double)(LMAX-LMIN)/NL;
   FILE *out;
   out=fopen(FILENAME,"w");
   red();
   for(lambda=LMIN;lambda<=LMAX;lambda+=dlambda) {
      ra=0.;
      idos=0;
      for(k=1;k<N;k++) {      /* Determina las veces que R_n<0        */
         rd=2.-alfa[k]*lambda-ra;
         if(fabs(rd)<1e-50) {
            idos++;
            k++;
            ra=0.;
         } else {
            if(rd<0.) idos++;
            ra=1./rd;
         }
      }
      fprintf(out,"%8.6lf   %8.6lf\n",lambda,(double)idos/N);
   }
   fclose(out);
}
