/* Cdigo para estudiar la estructura de bandas en un potencial
   peridico no local separable y la masa efectiva analticamente.
   Francisco Domnguez-Adame.                                         */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define E_MIN    -6.5              /* Energa mnima (eV)             */
#define E_MAX    -0.5              /* Energa mxima (eV)             */
#define E_B      -6.39             /* Energa del mnimo (eV)         */
#define E_T      -0.89             /* Energa del mximo (eV)         */
#define NE     1000                /* Nmero de pasos en energas     */
#define C         0.507            /* 2mL^{2}/hbar^{2} [eV^{-1}]      */
#define FILENAME  "DATOS.DAT"      /* Archivo de datos                */
#define PI        3.141592654

void main(void) {
    float e,de=(E_MAX-E_MIN)/(float)NE,k0l,g,mef,p;
    FILE *out;
    out=fopen(FILENAME,"w");
    k0l=log(cosh(sqrt(-C*E_B))+cosh(sqrt(-C*E_T)));
    g=0.5*exp(k0l);
    mef=sqrt(g*g)/log(g+sqrt(g*g-1.));
    fprintf(out,"Masa efectiva =  %5.4f   \n",mef);
    fprintf(out,"Nivel atmico =  %5.4f eV\n",-k0l*k0l/C);
    for(e=E_MIN;e<=E_MAX;e+=de){
        p=cosh(sqrt(-C*e))-g;
        if(fabs(p)<1.) fprintf(out,"%8.7f  %8.7f\n",acos(p)/PI,e);
    }
    fclose(out);
}
