/* Cdigo para el clculo de la estructura de bandas en planos
   Cu-O en YBaCuO, utilizando la aproximacin de enlace fuerte.
   Francisco Domnguez-Adame                                          */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define N  200          /* Nmero divisiones en cada intervalo        */
#define E1  -0.20       /* Parmetro E_1 en eV                        */
#define E2  -0.50       /* Parmetro E_2 en eV                        */
#define G1   1.32       /* Parmetro gamma_1 en eV                    */
#define G2   1.56       /* Parmetro gamma_2 en eV                    */
#define PI 3.141592654
#define FILENAME  "DATOS.DAT"

void main(void) {
   double e1,e2,kxa,kyb,dk=(double) PI/N;
   int i=0;
   FILE *out;
   out=fopen(FILENAME,"w");
   e1=E1;                                /* Primer intervalo, k_yb=0  */
   for(kxa=0.;kxa<=PI;kxa+=dk,i++) {
      e2=E2+G2*sqrt(0.5-0.5*cos(kxa));
      fprintf(out,"%5d   %8.6lf   %8.6lf\n",i,e1,e2);
   }
   for(kyb=0.;kyb<=PI;kyb+=dk,i++) {     /* Segundo intervalo, k_xa=PI*/
      e1=E1+G1*sqrt(1.-cos(kyb));
      e2=E2+G2*sqrt(1.5-0.5*cos(kyb));
      fprintf(out,"%5d   %8.6lf   %8.6lf\n",i,e1,e2);
   }
   e1=E1+sqrt(2.)*G1;                    /* Tercer intervalo, k_yb=PI */
   for(kxa=PI;kxa>=0.;kxa-=dk,i++) {
      e2=E2+G2*sqrt(1.5-0.5*cos(kxa));
      fprintf(out,"%5d   %8.6lf   %8.6lf\n",i,e1,e2);
   }
   for(kyb=PI;kyb>=0.;kyb-=dk,i++) {     /* Cuarto intervalo, k_xa=0  */
      e1=E1+G1*sqrt(1.-cos(kyb));
      e2=E2+G2*sqrt(0.5-0.5*cos(kyb));
      fprintf(out,"%5d   %8.6lf   %8.6lf\n",i,e1,e2);
   }
   fclose(out);
}
